let messageToImport = {};
let thunderbirdMessageId = "";
let attachments = [];
let contactsPromises = [];
let contactWindows = [];
let projectWindows = [];
let isAssignEmailToProject = null;

function importEmailToCRM(isInbound) {

    messageToImport = {};
    thunderbirdMessageId = "";
    attachments = [];
    contactsPromises = [];
    contactWindows = [];
    projectWindows = [];
    isAssignEmailToProject = null;

    messageToImport.userAuth = getUserAuth();
    messageToImport.message = {};
    messageToImport.message.idContacts = [];
    messageToImport.message.idProject = "";
    messageToImport.message.isInbound = isInbound;

    crmVisionSoapApi.getServerUrl(messageToImport.userAuth['company_name'], getServerUrlDataHandler);
}

function processProjects() {
    let projectsSetting = Services.prefs.getStringPref("extensions.crm_vision_extension.settings.projectsetting");
    if (projectsSetting === 'pytaj') {
        crmVisionSoapApi.getProjectsByIdContacts(messageToImport, getProjectsByIdContactsHandler).then(function () {
            let interval = window.setInterval(function () {
                if (projectWindows.length === 0 || projectWindows.filter(w => w.closed).length === projectWindows.length) {
                    window.clearInterval(interval);
                    if (projectWindows.length === 0 || isAssignEmailToProject !== null) {
                        crmVisionSoapApi.importEmail(messageToImport, getImportEmailDataHandler);
                    }
                }
            }, 100);
        });
    } else {
        crmVisionSoapApi.importEmail(messageToImport, getImportEmailDataHandler);
    }
}

function processImportAttachments() {
    let attachmentsSetting = Services.prefs.getStringPref("extensions.crm_vision_extension.settings.attachsetting");
    if (attachmentsSetting !== 'nie_dodawaj') {
        loadAttachments();
    }
}

function openConfigurationWindow() {
    window.open('chrome://crm_vision_extension/content/views/options.xhtml', 'configurationWindow',
        'chrome,resizable=no,titlebar,centerscreen,dialog=yes,menubar=yes'
    );
}

window.addEventListener("message", function (event) {
    let data = event.data;

    if (data.action === 'chooseContact') {
        messageToImport.message.idContacts.push(data.idContact);
    }

    if (data.action === 'chooseProject') {
        messageToImport.message.idProject = data.idProject;
        isAssignEmailToProject = data.isAssignEmailToProject;
    }

    if (data.source === 'selectAttachments') {
        let selectedAttachmentsUrls = data.selectedAttachmentsUrls;
        if (selectedAttachmentsUrls) {
            let loader = window.open('chrome://crm_vision_extension/content/views/loader.xhtml', 'attachmentsImportLoader',
                'chrome,toolbar=yes,titlebar,centerscreen,directories=no,status=yes,menubar=yes,scrollbars=no,resizable=yes,copyhistory=no,width=400,height=400'
            );

            let totalUploadedFiles = 0;
            loader.addEventListener("message", function (event) {
                if (event.data === 'uploadFinished') {
                    totalUploadedFiles++;
                    if (selectedAttachmentsUrls.length === totalUploadedFiles) {
                        loader.close();
                    }
                }
            });

            selectedAttachmentsUrls.forEach(attachmentUrl => {
                let attachmentToImport = attachments.filter(attachment => attachment.url === attachmentUrl)[0];
                let attachmentFile = saveAttachmentToTemp(attachmentToImport);
                importAttachment(loader, attachmentFile);
            });
        }
    }
}, false);