crmVisionSoapApi = {
    _ServerRedirectURL: 'https://serwer2.crmvision-online.pl/translateName/RedirectWSService',
    _ServerURL: 'http://localhost:8282/RedirectWSServer/RedirectWSService',
    _NsuriRedirect: 'http://redirect.webservice.crm.yourvision.pl/',
    _Nsuri: 'http://mail.webservice.crm.yourvision.pl/',
    _UtilsLoaded: false,
    _Debug: false,

    getServerUrl: function (companyName, dataHandler) {
        let serverURL = this._ServerRedirectURL;
        let soapMethod = 'get_server_url';
        let nsuri = this._NsuriRedirect;

        let params = {};
        params['company_name'] = companyName;

        let soapRequest = SOAPTools.buildRequest(nsuri, soapMethod, params);

        return SOAPTools.executeRequestFetch(serverURL, soapRequest, soapMethod, dataHandler);
    },
    getContacts: function (messageToImport, email, dataHandler) {
        let serverURL = messageToImport.globalServerUrl;
        let soapMethod = 'getContacts';
        let nsuri = this._Nsuri;

        let params = {};
        params['login'] = messageToImport.userAuth.username;
        params['password'] = messageToImport.userAuth.password;
        params['email'] = email;

        let soapRequest = SOAPTools.buildRequest(nsuri, soapMethod, params);

        return SOAPTools.executeRequestFetch(serverURL, soapRequest, soapMethod, dataHandler);
    },
    getProjectsByIdContacts: function (messageToImport, dataHandler) {
        let serverURL = messageToImport.globalServerUrl;
        let soapMethod = 'getProjectsByIdContacts';
        let nsuri = this._Nsuri;

        let params = {};
        params['login'] = messageToImport.userAuth.username;
        params['password'] = messageToImport.userAuth.password;
        params['date'] = messageToImport.message.emailDate;
        params['idContacts'] = messageToImport.message.idContacts.join(',');

        let soapRequest = SOAPTools.buildRequest(nsuri, soapMethod, params);

        return SOAPTools.executeRequestFetch(serverURL, soapRequest, soapMethod, dataHandler);
    },
    importEmail: function (messageToImport, dataHandler) {
        let serverURL = messageToImport.globalServerUrl;
        let soapMethod = 'importEmail';
        let nsuri = this._Nsuri;
		let controlPattern = /[\u0000-\u001F\u007F-\u009F]/g ; 

        let params = {};
        params['login'] = messageToImport.userAuth.username;
        params['password'] = messageToImport.userAuth.password;
        params['title'] = messageToImport.message.subject.replaceAll(controlPattern, "");
        params['body'] = messageToImport.message.emailBodyPlain.replaceAll(controlPattern, "");
        params['bodyHTML'] = messageToImport.message.emailBodyHTML.replaceAll(controlPattern, "");
        params['date'] = messageToImport.message.emailDate;
        params['emails'] = messageToImport.message.emails;
        params['priority'] = messageToImport.message.priority;
        params['incoming'] = messageToImport.message.isInbound;
        params['outerId'] = messageToImport.message.outerId;
        params['idProject'] = messageToImport.message.idProject;
        params['idContacts'] = messageToImport.message.idContacts;

        let soapRequest = SOAPTools.buildRequest(nsuri, soapMethod, params);

        return SOAPTools.executeRequestFetch(serverURL, soapRequest, soapMethod, dataHandler);
    },
    importAttachment: function (messageToImport, attachment) {
        let serverURL = messageToImport.globalServerUrl;
        let soapMethod = 'importAttachment';
        let nsuri = this._Nsuri;

        let params = {};
        params['login'] = messageToImport.userAuth.username;
        params['password'] = messageToImport.userAuth.password;
        params['outerId'] = messageToImport.message.outerId;
        params['fileName'] = attachment.name;
        params['content'] = attachment.content;

        let soapRequest = SOAPTools.buildRequest(nsuri, soapMethod, params);
        let requestResult = SOAPTools.executeRequestXmlHttpRequest(soapRequest, serverURL);

        return SOAPTools.prepareResultXmlHttpResult(requestResult, soapMethod);
    },
    checkUser: function (userAuth, dataHandler) {
        let serverURL = userAuth.serverUrl;
        let soapMethod = 'checkUser';
        let nsuri = this._Nsuri;

        let params = {};
        params['login'] = userAuth.username;
        params['password'] = userAuth.password;

        let soapRequest = SOAPTools.buildRequest(nsuri, soapMethod, params);

        return SOAPTools.executeRequestFetch(serverURL, soapRequest, soapMethod, dataHandler);
    },
    checkIfEmailExists: function (messageToImport, dataHandler) {
        let serverURL = messageToImport.globalServerUrl;
        let soapMethod = 'checkIfEmailExists';
        let nsuri = this._Nsuri;

        let params = {};
        params['login'] = messageToImport.userAuth.username;
        params['password'] = messageToImport.userAuth.password;
        params['outerId'] = messageToImport.message.outerId;

        let soapRequest = SOAPTools.buildRequest(nsuri, soapMethod, params);

        return SOAPTools.executeRequestFetch(serverURL, soapRequest, soapMethod, dataHandler);
    }
}

