function AttachmentWorker() {

    const attachmentListener = {
        attachments: null,
        msgUri: null,

        QueryInterface: function (iid) {
            if (iid.equals(Components.interfaces.nsIStreamListener) ||
                iid.equals(Components.interfaces.nsIMsgHeaderSink) ||
                iid.equals(Components.interfaces.nsISupports)) {
                return this;
            } else {
                throw Components.results.NS_NOINTERFACE;
                return 0;
            }
        },

        onStartRequest: function (aRequest, aContext) {
            const channel = aRequest.QueryInterface(Components.interfaces.nsIChannel);
            channel.URI.QueryInterface(Components.interfaces.nsIMsgMailNewsUrl);
            channel.URI.msgHeaderSink = this;
        },

        onStopRequest: function (aRequest, aContext, aStatusCode) {

            attachments = [...this.attachments];

            let attachmentsSetting = Services.prefs.getStringPref("extensions.crm_vision_extension.settings.attachsetting");
            if (this.attachments.length > 0) {
                if (attachmentsSetting === 'dodawaj') {
                    let loader = window.open('chrome://crm_vision_extension/content/views/loader.xhtml', 'attachmentsImportLoader',
                        'chrome,toolbar=yes,titlebar,centerscreen,directories=no,status=yes,menubar=yes,scrollbars=no,resizable=yes,copyhistory=no,width=400,height=400'
                    );
                    let totalUploadedFiles = 0;
                    loader.addEventListener("message", function (event) {
                        if (event.data === 'uploadFinished') {
                            totalUploadedFiles++;
                            if (attachments.length === totalUploadedFiles) {
                                loader.close();
                            }
                        }
                    });

                    this.attachments.forEach(attachment => {
                        let attachmentFile = saveAttachmentToTemp(attachment);
                        importAttachment(loader, attachmentFile);
                    });
                } else {
                    let attachmentsWindow = window.open('chrome://crm_vision_extension/content/views/attachments.xhtml', 'attachmentsWindow',
                        'chrome,toolbar=yes,titlebar,centerscreen,directories=no,status=yes,menubar=yes,scrollbars=no,resizable=yes,copyhistory=no,height=470,width=400'
                    );
                    let attachmentsWindowDTO = [];

                    this.attachments.forEach(attachment => {
                        let objToDTO = {};
                        objToDTO.displayName = attachment.displayName;
                        objToDTO.url = attachment.url;

                        attachmentsWindowDTO.push(objToDTO);
                    });

                    attachmentsWindow.addEventListener("DOMContentLoaded", function () {
                        attachmentsWindow.postMessage(attachmentsWindowDTO);
                    });
                }
            }
        },

        onDataAvailable: function (aRequest, aContext, aInputStream, aOffset, aCount) {
        },

        onStartHeaders: function () {
        },

        onEndHeaders: function () {
        },

        processHeaders: function (headerNameEnumerator, headerValueEnumerator, dontCollectAddress) {
        },

        handleAttachment: function (contentType, url, displayName, uri, isExternalAttachment) {
            if (contentType !== "text/html" && contentType !== "text/x-moz-deleted" && contentType !== "text/x-vcard") {
                this.attachments[this.attachments.length] =
                    {
                        contentType: contentType,
                        url: url,
                        displayName: displayName,
                        uri: uri
                    }
            }
        },

        onEndAllAttachments: function () {
        },

        onEndMsgDownload: function (aUrl) {
        },

        onEndMsgHeaders: function (aUrl) {
        },

        onMsgHasRemoteContent: function (aMsgHdr) {
        },

        getSecurityInfo: function () {
        },

        setSecurityInfo: function (aSecurityInfo) {
        },

        getDummyMsgHeader: function () {
        }
    };
    return attachmentListener;
}