var {Services} = ChromeUtils.import("resource://gre/modules/Services.jsm");
Services.scriptloader.loadSubScript("chrome://crm_vision_extension/content/importEmail/soapTools.js", this, "UTF-8");
Services.scriptloader.loadSubScript("chrome://crm_vision_extension/content/importEmail/soapapi.js", this, "UTF-8");
Services.scriptloader.loadSubScript("chrome://crm_vision_extension/content/importEmail.js", this, "UTF-8");
Services.scriptloader.loadSubScript("chrome://crm_vision_extension/content/importEmail/datahandlers.js", this, "UTF-8");
Services.scriptloader.loadSubScript("chrome://crm_vision_extension/content/importEmail/common.js", this, "UTF-8");
Services.scriptloader.loadSubScript("chrome://crm_vision_extension/content/importEmail/workers.js", this, "UTF-8");
Services.scriptloader.loadSubScript("chrome://crm_vision_extension/content/notifyTools.js", this, "UTF-8");

function onLoad(isAddonActivationWhileWindowIsOpen) {
    let namespace = WL.scopeName;
    
    // Conditionally load a script for the windows plattform
    if (!isAddonActivationWhileWindowIsOpen) {
        return;
    }

    let menuPopup = window.MozXULElement.parseXULToFragment(`
    <html:link rel="stylesheet" href="chrome://crm_vision_extension/content/skin/crmvision.css"/>
    <menu id="crmvision_mainMenu"
    label="CRM Vision"    
    class="crmvision-icon-lnk ${namespace}">
        <menupopup id="crmvision_menuPopup">
            <menuitem class="menuitem-iconic crmvision-icon-lnk" label="Konfiguracja" oncommand="window.${namespace}.openConfigurationWindow();"/>
            <menuseparator/>
            <menuitem class="menuitem-iconic crmvision-icon-lnk-in" label="Dodaj wiadomość odebraną" oncommand="window.${namespace}.importEmailToCRM(true);"/>
            <menuitem class="menuitem-iconic crmvision-icon-lnk-out" label="Dodaj wiadomość wysłaną" oncommand="window.${namespace}.importEmailToCRM(false);"/>
        </menupopup>
    </menu>
    `);

    let menuContext = window.MozXULElement.parseXULToFragment(`
	<menuitem id="crmvision_context_addtocrmvision_inbound"
		class="menuitem-iconic crmvision-icon-lnk-in ${namespace}" 
		label="CRM - dodaj wiadomość odebraną"
		oncommand="window.${namespace}.importEmailToCRM(true);"/>
	
	<menuitem id="crmvision_context_addtocrmvision_outbound"
		class="menuitem-iconic crmvision-icon-lnk-out ${namespace}"
		label="CRM - dodaj wiadomość wysłaną"
		oncommand="window.${namespace}.importEmailToCRM(false);"/>
    `);

    let buttonIn = window.MozXULElement.parseXULToFragment(`
        <toolbarbutton
        id="crmvision-toolbar-button-1"
        class="toolbarbutton-1 chromeclass-toolbar-additional crmvision-toolbar-button-in ${namespace}"
        label="Dodaj odebraną"
        tooltiptext="Dodaj wiadomość odebraną"
        oncommand="window.${namespace}.importEmailToCRM(true);"
        removable="true"/>`);

    let buttonOut = window.MozXULElement.parseXULToFragment(`<toolbarbutton
        id="crmvision-toolbar-button-2"
        class="toolbarbutton-1 chromeclass-toolbar-additional crmvision-toolbar-button-out ${namespace}"
        label="Dodaj wysłaną"
        tooltiptext="Dodaj wiadomość wysłaną"
        oncommand="window.${namespace}.importEmailToCRM(false);"
        removable="true"/>`);

    let interval = window.setInterval(function() {
        if(document.readyState === 'complete') {

            window.document.getElementById("taskPopup").appendChild(menuPopup);
            window.document.getElementById("mailContext").append(menuContext);
            window.document.getElementById('mail-bar3').append(buttonIn);
            window.document.getElementById('mail-bar3').append(buttonOut);

            window.clearInterval(interval);
        }
    },100);
}

function onUnload(isAddonDeactivationWhileWindowIsOpen) {

    // The add-on must unload its content (UI) from the window, if the add-on is being deactivated.
    // This can be skipped if the window is being closed, either by the user or because Thunderbird
    // itself is shut down.
    if (!isAddonDeactivationWhileWindowIsOpen)
        return;

    // Remove all our added elements which are tagged with a unique classname
    let elements = Array.from(window.document.getElementsByClassName(namespace));
    for (let element of elements) {
        element.remove();
    }
}