﻿const Services = window.opener.Services;

window.addEventListener("message", receiveMessage, false);

function receiveMessage(event) {
    let attachments = event.data;
    let attachmentsSetting = Services.prefs.getStringPref("extensions.crm_vision_extension.settings.attachsetting");

    attachments.forEach(attachment => {
        let option = document.createElement("option");
        option.value = attachment.url;
        option.text = attachment.displayName;

        if (attachmentsSetting === "pytaj_zaznacz") {
            option.selected = true;
        }

        document.getElementById("attachments").appendChild(option);
    });
}

function selectAllAttachments(show) {
    Array.from(document.getElementById('attachments').children).forEach(elem => elem.selected = show);
}

function getSelected() {

    let message = {
        source: "selectAttachments",
        selectedAttachmentsUrls: ""
    }
    let selectedAttachments = Array.from(document.getElementById('attachments').selectedOptions);

    if (selectedAttachments.length > 0) {
        message.selectedAttachmentsUrls = selectedAttachments.map(attachment => attachment.value);
        window.opener.postMessage(message);
    }
    window.close();
}