const Services = window.opener.Services;

const attachmentSettings = new Map([
    ["pytaj_zaznacz", "Pytaj czy dodać - domyślnie zaznacz wszystkie"],
    ["pytaj_nie_zaznacz", "Pytaj czy dodać - domyślnie nie zaznaczaj"],
    ["dodawaj", "Zawsze dodawaj do CRM"],
    ["nie_dodawaj", "Nigdy nie dodawaj do CRM"]
]);

const projectSettings = new Map([
    ["pytaj", "Zawsze pytaj czy przypisać"],
    ["nie_dodawaj", "Nigdy nie przypisuj"]
]);

document.addEventListener("DOMContentLoaded", (event) => {
    let companyName = document.getElementById('companyName');
    let login = document.getElementById('login');

    let attachmentSetting = Services.prefs.getStringPref("extensions.crm_vision_extension.settings.attachsetting");
    let projectSetting = Services.prefs.getStringPref("extensions.crm_vision_extension.settings.projectsetting");

    companyName.value = Services.prefs.getStringPref("extensions.crm_vision_extension.settings.companyname");
    login.value = Services.prefs.getStringPref("extensions.crm_vision_extension.settings.username");

    let attachmentOptions = document.getElementById('attachments');
    let projectOptions = document.getElementById('projects');
    attachmentSettings.forEach((value, key) => {
        let option = document.createElement("option");
        option.value = key;
        option.text = value;

        if (key === attachmentSetting) {
            option.selected = true;
        }

        attachmentOptions.appendChild(option);
    });

    projectSettings.forEach((value, key) => {
        let option = document.createElement("option");
        option.value = key;
        option.text = value;

        if (key === projectSetting) {
            option.selected = true;
        }
        projectOptions.appendChild(option);
    });
});

function testConnection() {

    let companyName = document.getElementById('companyName').value;
    let login = document.getElementById('login').value;
    let password = document.getElementById('password').value;

    if (password.length === 0) {
        password = Services.prefs.getStringPref("extensions.crm_vision_extension.settings.password");
    } else {
        password = hex_md5(password);
    }

    let userAuth = {
        username: login,
        password: password,
        company_name: companyName
    }

    crmVisionSoapApi.getServerUrl(userAuth.company_name, function (data) {
        userAuth['serverUrl'] = SOAPTools.prepareResultFetch(data).value;

        if (userAuth.serverUrl && (userAuth.serverUrl.startsWith('http://') || userAuth.serverUrl.startsWith('https://'))) {
            crmVisionSoapApi.checkUser(userAuth, function (data) {

                let result = SOAPTools.prepareResultFetch(data).value;

                let resultCode = result.substring(0, 2);
                let resultMessage = result.substring(2);

                if (resultCode === '00') {
                    Services.prompt.confirmEx(null, "CRM Vision", resultMessage, Services.prompt.BUTTON_TITLE_OK, "OK", null, null, null, {value: true});
                } else {
                    Services.prompt.alert(window, "CRM Vision", resultMessage);
                }
            });
        } else {
            Services.prompt.alert(window, "CRM Vision", `Wystąpił błąd pobrania adresu. Sprawdź identyfikator firmy.`);
        }

    });
}

function saveSettings() {
    let companyName = document.getElementById('companyName').value.trim();
    let login = document.getElementById('login').value.trim();
    let password = document.getElementById('password').value;
    let attachmentSetting = document.getElementById('attachments').value;
    let projectSetting = document.getElementById('projects').value;

    if (password.length > 0) {
        password = hex_md5(password);
        Services.prefs.setStringPref("extensions.crm_vision_extension.settings.password", password);
    }

    Services.prefs.setStringPref("extensions.crm_vision_extension.settings.attachsetting", attachmentSetting);
    Services.prefs.setStringPref("extensions.crm_vision_extension.settings.projectsetting", projectSetting);
    Services.prefs.setStringPref("extensions.crm_vision_extension.settings.companyname", companyName);
    Services.prefs.setStringPref("extensions.crm_vision_extension.settings.username", login);

    window.close();
}